/* CDTray.c by Andrew I. Reshin. Last modified 19.05.2001. */
/*  Eject/close CD tray (DOS/Windows 9X/NT(Eject only)).   */
/*              Requires MSCDEX installed.                 */

typedef struct _IOCTL_REQ {
 unsigned char Length;
 unsigned char SubUnit;
 unsigned char Command;
 unsigned short Status;
 unsigned char Reserved[8];
 unsigned char Media;
 unsigned short Offset;
 unsigned short Segment;
} IOCTL_REQ;

/* Open or close CD-tray by drive letter */
/* return zero or non-zero on error      */

int cdtray(char cDrive,char cAction)
{
IOCTL_REQ Req={sizeof(IOCTL_REQ),0,12,0,0,0,0,0,0,0,0,0,0,0,0};
unsigned short Buf=(cAction=='O')?0:5;
unsigned short RqOffset=(unsigned short)&Req;
unsigned short BufOffset=(unsigned short)&Buf;
unsigned short nDrive=cDrive-'A';

asm mov cx,nDrive
asm mov dx,BufOffset
asm mov Req.Offset,dx
asm mov dx,es
asm mov Req.Segment,dx
asm mov ax,1510h
asm mov bx,RqOffset
asm int 2Fh
return ((Req.Status & 0x8000) || !(Req.Status & 0x0100))?-1:0;
}

/* Main function accept two letters as argument:          */
/* first  - A-Z (disk letter), second - C[lose] or O[pen] */
/* and return zero or non-zero value on error             */

int main(int argc,char *argv[])
{
return (
 argc==2 && *argv[1]>='A' && *argv[1]<='Z' &&
 (*(argv[1]+1)=='O' || *(argv[1]+1)=='C')
 )?cdtray(*argv[1],*(argv[1]+1)):-1;
}